local reg_item = ocutil.safe_register_item
local reg_node = ocutil.safe_register_node

reg_item ("aluminum:lump",{
    description = "Aluminum Lump",
    inventory_image = "aluminum_aluminum_lump.png"
})

minetest.register_craft({
    type = "cooking",
    output = "aluminum:ingot",
    recipe = "aluminum:lump"
})

reg_node ("aluminum:ore",{
    description = "Aluminum Ore",
    tiles = {"default_stone.png^aluminum_mineral_aluminum.png"},
    is_ground_content = true,
    groups = {cracky = 2},
    drop = "aluminum:lump",
    sounds = default.sound_stone()
})

reg_item ("aluminum:ingot",{
    description = "Aluminum Ingot",
    inventory_image = "aluminum_aluminum_ingot.png"
})

reg_node ("aluminum:block",{
    description="Aluminum Block",
    tiles={"aluminum_aluminum_block.png"},
    is_ground_content = false,
    groups = {cracky = 1, level = 2},
    sounds = default.node_sound_metal_defaults()
})

minetest.register_craft({
    output = "aluminum:block",
    recipe = {
        {"aluminum:ingot", "aluminum:ingot", "aluminum:ingot"},
        {"aluminum:ingot", "aluminum:ingot", "aluminum:ingot"},
        {"aluminum:ingot", "aluminum:ingot", "aluminum:ingot"},
    }
})

minetest.register_craft({
    output = "aluminum:ingot 9",
    type = "shapeless",
    recipe = {"aluminum:block"}
})

-- For mapgen
minetest.register_ore({
    ore_type = "scatter",
    ore = "aluminum:ore",
    wherein = "default:stone",
    clust_scarcity = 15 * 15 * 15,
    clust_num_ores = 20,
    clust_size = 5,
    y_max = -32,
    y_min = -31000,
})
