-- ===================================================================

local reg_node = ocutil.safe_register_node
local sra      = ocutil.safe_register_alias

local neednode
local img

-- ===================================================================

img = "darkage_iron_grille.png"

reg_node ("darkage:iron_grille", {
    description         = "Iron Grille"                ,
    drawtype            = "glasslike"                  ,
    tiles               = { img }                      ,
    inventory_image     = img                          ,
    wield_image         = img                          ,
    is_ground_content   = false                        ,
    paramtype           = "light"                      ,
    sunlight_propagates = true                         ,
    groups              = { cracky=3, not_cuttable=1 } ,
    sounds              = default.sound_stone()        ,
})

-- ===================================================================

neednode = "darkage:basalt"
--
if  minetest.registered_nodes [neednode] == nil then
    minetest.register_node (":" .. neednode, {
        description = "Basalt"                      ,
        groups      = { cracky = 3, stone = 1 }     ,
        sounds      = default.sound_stone()         ,
        tiles       = { "darkage_basalt.png" }      ,

        is_ground_content = true ,
    })
end

-- ===================================================================

neednode = "darkage:basalt_rubble"
--
if  minetest.registered_nodes [neednode] == nil then
    minetest.register_node (":" .. neednode, {
        description = "Basalt Rubble"                   ,
        groups      = { cracky = 3, stone = 2 }         ,
        sounds      = default.sound_stone()             ,
        tiles       = { "darkage_basalt_rubble.png" }   ,

        is_ground_content = false ,
    })
end

-- ===================================================================

neednode = "darkage:basalt_brick"
--
if  minetest.registered_nodes [neednode] == nil then
    minetest.register_node (":" .. neednode, {
        description = "Basalt Brick"                    ,
        groups      = { cracky = 2, stone = 1 }         ,
        sounds      = default.sound_stone()             ,
        tiles       = { "darkage_basalt_brick.png" }    ,

        is_ground_content = false ,
    })
end

-- ===================================================================

neednode = "darkage:basalt_block"
--
if  minetest.registered_nodes [neednode] == nil then
    minetest.register_node (":" .. neednode, {
        description = "Basalt Block"                    ,
        groups      = { cracky = 2, stone = 1 }         ,
        sounds      = default.sound_stone()             ,
        tiles       = { "darkage_basalt_block.png" }    ,

        is_ground_content = false ,
    })
end

-- ===================================================================

neednode = "darkage:chain"
--
if  minetest.registered_nodes [neednode] == nil then
    minetest.register_node (":" .. neednode, {
        description = "Chain",
        drawtype = "signlike",
        tiles = { "darkage_chain.png" } ,
        inventory_image = "darkage_chain.png" ,
        wield_image = "darkage_chain.png" ,
        paramtype = "light" ,
        paramtype2 = "wallmounted" ,
        is_ground_content = false, 
        walkable = false ,
        climbable = true ,

        selection_box = {
            type = "wallmounted",
            --wall_top = = <default>
            --wall_bottom = = <default>
            --wall_side = = <default>
        } ,

        groups = {
            snappy=1, cracky=2,
            oddly_breakable_by_hand=2, not_cuttable=1
        } ,
        legacy_wallmounted = true ,
    })
end

-- ===================================================================

neednode = "darkage:chalk"
--
if minetest.registered_nodes [neednode] == nil then
    minetest.register_node (":" .. neednode, {
        description = "Chalk"                                 ,
        tiles       = { "darkage_chalk.png" }                 ,
        groups      = { crumbly=2, cracky=2, not_cuttable=1 } ,
        sounds      = default.sound_stone()                   ,

        is_ground_content = true ,
    })
end

-- ===================================================================

neednode = "darkage:glass_square"
--
if minetest.registered_nodes [neednode] == nil then
    minetest.register_node (":" .. neednode, {
        description = "Square Glass",
        drawtype = "glasslike",
        tiles = { "darkage_glass_square.png" },
        paramtype = "light",
        use_texture_alpha = true,
        sunlight_propagates = true,
        sounds = default.node_sound_glass_defaults(),
        groups = {cracky=3,oddly_breakable_by_hand=3},
    })
end

-- ===================================================================

neednode = "darkage:lamp"
--
if  minetest.registered_nodes [neednode] == nil then
    minetest.register_node (":" .. neednode, {
        description = "Lamp" ,
        tiles = { "darkage_lamp.png" } ,
        paramtype = "light" ,
        sunlight_propagates = true,
        light_source = default.LIGHT_MAX-1,
        sounds = default.node_sound_glass_defaults() ,

        groups = { snappy=2, cracky=3, oddly_breakable_by_hand=3,
flammable=1 , not_cuttable=1 } ,
    })
end

-- ===================================================================

neednode = "darkage:marble_tile"
--
if  minetest.registered_nodes [neednode] == nil then
    minetest.register_node (":" .. neednode, {
        description = "Marble Tile"                 ,
        tiles       = { "darkage_marble_tile.png" } ,
        groups      = { cracky=2 }                  ,
        sounds      = default.sound_stone()         ,

        is_ground_content = false ,
    })
end

-- ===================================================================

neednode = "darkage:slate_tile"
--
if  minetest.registered_nodes [neednode] == nil then
    minetest.register_node (":" .. neednode, {
        description = "Slate Tile",
        tiles = { "darkage_slate_tile.png" } ,
        is_ground_content = false,
        groups = { cracky=2 } ,
        sounds = default.sound_stone() ,
    })
end

-- ===================================================================

sra ("darkage:stone_brick" ,
     "default:stonebrick"  )

-- ===================================================================
-- End of module.
