local cvt       = default.convert_node
local reg_alias = ocutil.safe_register_alias
local reg_node  = ocutil.safe_register_node

local img
local neednode

-- ===================================================================

neednode = "ethereal:crystal_block"
--
if ocutil.thing_missing (neednode) then
    reg_node (neednode, {
        description = "Crystal Block" ,
        tiles = { "ethereal_crystal_block.png"} ,
        paramtype = "light",
        light_source = 9,
        is_ground_content = false,

        groups = {
            cracky=1, level=2, puts_out_fire=1,
            cools_lava = 1
        } ,

        sounds = default.sound_glass() ,
    })
end

-- ===================================================================

neednode = "ethereal:glostone"
--
if ocutil.thing_missing (neednode) then
    reg_node (neednode, {
        description = "Glo Stone" ,
        tiles = { "ethereal_glostone.png"} ,
        paramtype = "light",
        light_source = 13,
        drop = "ethereal:glostone",
        groups = {cracky = 3},
        sounds = default.sound_stone() ,
    })
end

-- ===================================================================

neednode = "ethereal:icebrick"
--
if ocutil.thing_missing (neednode) then
    reg_node (neednode, {
        description = "Ice Brick" ,
        tiles = { "ethereal_icebrick.png"} ,
        paramtype = "light",
        freezemelt = "default:water_source" ,
        is_ground_content = false,
        groups = { cracky=3, puts_out_fire=1, cools_lava=1 } ,
        sounds = default.sound_glass() ,
    })
end

-- ===================================================================

neednode = "ethereal:illumishroom"
img      = "ethereal_illumishroom_red.png"
--
if ocutil.thing_missing (neednode) then
    reg_node (neednode, {
        description = "Red Illumishroom"     ,
        drawtype    = "plantlike"            ,
        sounds      = default.sound_leaves() ,

        tiles               = { img } ,
        inventory_image     =   img   ,
        wield_image         =   img   ,
        paramtype           = "light" ,
        light_source        = 5       ,
        sunlight_propagates = true    ,
        walkable            = false   ,

        groups = {
            dig_immediate=3, attached_node=1, flammable=3
        } ,

        selection_box = {
            type  = "fixed" ,
            fixed = { -6/16, -0.5, -6/16, 6/16, 0.47, 6/16 }
        }
    })
end

-- ===================================================================

neednode = "ethereal:illumishroom2"
img      = "ethereal_illumishroom_green.png"
--
if ocutil.thing_missing (neednode) then
    reg_node (neednode, {
        description = "Green Illumishroom"   ,
        drawtype    = "plantlike"            ,
        sounds      = default.sound_leaves() ,

        tiles               = { img } ,
        inventory_image     =   img   ,
        wield_image         =   img   ,
        paramtype           = "light" ,
        light_source        = 5       ,
        sunlight_propagates = true    ,
        walkable            = false   ,

        groups = {
            dig_immediate=3, attached_node=1, flammable=3
        } ,

        selection_box = {
            type  = "fixed" ,
            fixed = { -6/16, -0.5, -6/16, 6/16, 0.47, 6/16 }
        }
    })
end

-- ===================================================================

neednode = "ethereal:illumishroom3"
img      = "ethereal_illumishroom_cyan.png"
--
if ocutil.thing_missing (neednode) then
    reg_node (neednode, {
        description = "Cyan Illumishroom"    ,
        drawtype    = "plantlike"            ,
        sounds      = default.sound_leaves() ,

        tiles               = { img } ,
        inventory_image     =   img   ,
        wield_image         =   img   ,
        paramtype           = "light" ,
        light_source        = 5       ,
        sunlight_propagates = true    ,
        walkable            = false   ,

        groups = {
            dig_immediate=3, attached_node=1, flammable=3
        } ,

        selection_box = {
            type  = "fixed" ,
            fixed = { -6/16, -0.5, -6/16, 6/16, 0.47, 6/16 }
        }
    })
end

-- ===================================================================

neednode = "ethereal:paper_wall"
img      = "ethereal_paper_wall.png"
--
if ocutil.thing_missing (neednode) then
    reg_node (neednode, {
        drawtype            = "nodebox"            ,
        description         = "Paper Wall"         ,
        sounds              = default.sound_wood() ,
        is_ground_content   = false                ,
        sunlight_propagates = true                 ,
        groups              = { snappy=3 }         ,

        tiles           = { img }   ,
        inventory_image =   img     ,
        wield_image     =   img     ,

        paramtype       = "light"   ,
        walkable        = true      ,
        paramtype2      = "facedir" ,

        selection_box = {
            type  = "fixed" ,
            fixed = { -0.5, -0.5, 5/11, 0.5, 0.5, 8/16 }
        } ,

        node_box = {
            type  = "fixed" ,
            fixed = {
                { -0.5, -0.5, 5/11, 0.5, 0.5, 8/16 }
            }
        }
    })
end

-- ===================================================================

neednode = "ethereal:dry_dirt"
--
if ocutil.thing_missing (neednode) then
    reg_node (neednode, {
        description       = "Dried Dirt"                ,
        tiles             = { "ethereal_dry_dirt.png" } ,
        is_ground_content = false                       ,
        groups            = { crumbly=3 }               ,
        sounds            = default.sound_dirt()        ,
    })
end

-- ===================================================================
 
local dirts = {
    "Crystal"
}

-- ===================================================================

for n = 1, #dirts do
    local desc = dirts [n]
    local name = desc:lower()

    reg_node ("ethereal:" .. name .. "_dirt", {
        description = desc.." Dirt" ,
 
        tiles = {
            "ethereal_grass_"..name.."_top.png" ,
            "default_dirt.png" ,
            {
                name = "default_dirt.png^ethereal_grass_" ..
name .. "_side.png" ,
                tileable_vertical = false
            }
        } ,

        is_ground_content = false ,

        groups = {
            crumbly=3, soil = 1, spreading_dirt_type=1
        } ,

        soil   = {
            base = "ethereal:"..name.."_dirt" ,
            dry  = "farming:soil"             ,
            wet  = "farming:soil_wet"         ,
        } ,

        drop   = "default:dirt" ,
        sounds = default.node_sound_dirt_defaults ({
            footstep = {
                name = "default_grass_footstep", gain = 0.25
            } ,
        }) ,
    })
end

-- ===================================================================

neednode = "ethereal:crystalgrass"
img      = "ethereal_crystalgrass.png"
--
if ocutil.thing_missing (neednode) then
    reg_node (neednode, {
        description     = "Crystal Grass"   ,
        drawtype        = "plantlike"       ,
        visual_scale    = 0.9               ,
        paramtype       = "light"           ,
        waving          = 1                 ,
        walkable        = false             ,
        buildable_to    = true              ,

        tiles           = { img }           ,
        inventory_image =   img             ,
        wield_image     =   img             ,

        sunlight_propagates = true ,
        groups = { snappy=3, flora=1, attached_node=1 } ,
        sounds = default.sound_leaves()                 ,

        selection_box = {
            type  = "fixed" ,
            fixed = { -5/16, -0.5, -5/16, 5/16, 5/16, 5/16 }
        }
    })
end

-- ===================================================================

cvt ("ethereal:bamboo_sprout"    , "bamboo:bamboo"         )
cvt ("ethereal:banana_wood"      , "default:acacia_wood"   )

cvt ("ethereal:yellow_wood"      , "default:wood"          )
cvt ("ethereal:fence_yellowwood" , "default:fence_wood"    )

cvt (  "ethereal:slab_banana_wood" ,
     "moreblocks:slab_acacia_wood" )

cvt ("ethereal:palmleaves"       , "default:palm_wood"     )
cvt ("ethereal:palm_trunk"       , "default:palm_trunk"    )
cvt ("ethereal:palm_wood"        , "default:palm_wood"     )

cvt ("ethereal:yellowleaves"     , "default:acacia_leaves" )
cvt ("ethereal:yellow_trunk"     , "default:acacia_trunk"  )

cvt (  "stairs:stair_frost_tree"             ,
     "ethereal:stair_frost_wood"             )

cvt ("  stairs:stair_outer_frost_tree"       ,
           "ethereal:stair_frost_wood_outer" )

-- ===================================================================

neednode = "ethereal:icebrick"
--
if ocutil.thing_missing (neednode) then
    reg_node (neednode, {
        description = "Ice Brick" ,
        tiles = { "ethereal_icebrick.png"} ,
        paramtype = "light",
        freezemelt = "default:water_source" ,
        is_ground_content = false,
        groups = { cracky=3, puts_out_fire=1, cools_lava=1 } ,
        sounds = default.sound_glass() ,
    })
end

-- ===================================================================
-- End of file.
