-- ===================================================================

local cvt = default.convert_node
local baselist
local neednode
local targetmod

-- ===================================================================

cvt ("moretrees:acorn"                        ,
     "air"                                    )
cvt ("moretrees:cedar_cone"                   ,
     "air"                                    )
cvt ("moretrees:pine_cone"                    ,
     "air"                                    )
cvt ("moretrees:pinecone"                     ,
     "air"                                    )

-- ===================================================================

local base_leaves_trunk = {

    "acacia"    , "beech"     , "birch"     , "cedar"     ,
    "date_palm" , "fir"       , "oak"       , "palm"      ,
    "pine"      , "poplar"    , "sequoia"   , "spruce"    ,
    "willow"    ,
}

for _,base in ipairs (base_leaves_trunk) do

    cvt ("moretrees:" .. base .. "_leaves"          ,
           "default:" .. base .. "_leaves"          )

    cvt ("moretrees:" .. base .. "_planks"          ,
           "default:" .. base .. "_wood"            )

    cvt ("moretrees:" .. base .. "_sapling"         ,
           "default:" .. base .. "_sapling"         )

    cvt ("moretrees:" .. base .. "_sapling_ongen"   ,
           "default:" .. base .. "_sapling"         )

    cvt ("moretrees:" .. base .. "_trunk"           ,
           "default:" .. base .. "_trunk"           )
end

-- ===================================================================

cvt ("moretrees:coconut"                      ,
     "default:coconut"                        )
cvt ("moretrees:coconut_0"                    ,
     "default:coconut"                        )
cvt ("moretrees:coconut_1"                    ,
     "default:coconut"                        )
cvt ("moretrees:coconut_2"                    ,
     "default:coconut"                        )
cvt ("moretrees:coconut_3"                    ,
     "default:coconut"                        )

-- ===================================================================

cvt ("moretrees:dates_fn"                     ,
     "default:date"                           )
cvt ("moretrees:dates_f1"                     ,
     "default:date"                           )
cvt ("moretrees:dates_f2"                     ,
     "default:date"                           )
cvt ("moretrees:dates_f3"                     ,
     "default:date"                           )
cvt ("moretrees:dates_f4"                     ,
     "default:date"                           )
cvt ("moretrees:dates_n"                      ,
     "default:date"                           )
cvt ("moretrees:dates_m0"                     ,
     "default:date"                           )
cvt ("moretrees:dates_f0"                     ,
     "default:date"                           )

-- ===================================================================

cvt ("moretrees:apple_blossoms"               ,
     "default:apple"                          )
cvt ("moretrees:fir_cone"                     ,
     "default:fir_cone"                       )
cvt ("moretrees:spruce_cone"                  ,
     "default:spruce_cone"                    )

-- ===================================================================

cvt ("moretrees:apple_tree_leaves"            ,
     "default:big_apple_leaves"               )
cvt ("moretrees:apple_tree_planks"            ,
     "default:big_apple_wood"                 )
cvt ("moretrees:apple_tree_sapling_ongen"     ,
     "default:big_apple_sapling"              )
cvt ("moretrees:apple_tree_trunk"             ,
     "default:big_apple_trunk"                )

-- ===================================================================

cvt ("moretrees:date_palm_mfruit_trunk"       ,
     "default:palm_trunk"                     )
cvt ("moretrees:date_palm_ffruit_trunk"       ,
     "default:palm_trunk"                     )

-- ===================================================================

cvt ("moretrees:fir_leaves_bright"            ,
     "default:fir_leaves"                     )

-- ===================================================================

cvt ("moretrees:jungletree_leaves_red"        ,
     "default:jungle_leaves"                  )
cvt ("moretrees:jungletree_leaves_yellow"     ,
     "default:jungle_leaves"                  )
cvt ("moretrees:jungletree_trunk"             ,
     "default:jungletree"                     )

-- ===================================================================

cvt ("moretrees:palm_fruit_trunk"             ,
     "default:palm_trunk"                     )

-- ===================================================================

cvt ("moretrees:rubber_tree_trunk_empty"      ,
     "default:rubber_trunk"                   )
cvt ("moretrees:rubber_tree_leaves"           ,
     "default:rubber_leaves"                  )
cvt ("moretrees:rubber_tree_planks"           ,
     "default:rubber_wood"                    )
cvt ("moretrees:rubber_tree_trunk"            ,
     "default:rubber_trunk"                   )

-- ===================================================================

targetmod = "moretrees"
baselist  = { "date_palm", "oak", "sequoia", "spruce" }

for k,v in pairs (baselist) do
    local nodepart = v .. "_planks"
    cvt (targetmod .. ":" .. nodepart ,
                         "default:"       .. nodepart )

    neednode = targetmod .. ":slope_" .. nodepart
    fromnode = targetmod .. ":"       .. nodepart

    if  coderblocks.has_moreblocks                  and
        minetest.registered_nodes [neednode] == nil and
        minetest.registered_nodes [fromnode] ~= nil then

        stairsplus:register_all (targetmod, nodepart, fromnode,
        {
            groups      = {
                snappy=1, choppy=2,
                oddly_breakable_by_hand=2,
                flammable=3,
                not_in_creative_inventory=1
            } ,

            description = v .. " planks"                     ,
            tiles       = { "default_" .. v .. "_wood.png" } ,
        })
    end
end

-- ===================================================================

cvt ("moretrees:panel_spruce_planks_1"        ,
     "moretrees:panel_spruce_planks"          )
cvt ("moretrees:panel_spruce_planks_2"        ,
     "moretrees:panel_spruce_planks"          )

cvt ("moretrees:slab_spruce_planks_1"         ,
     "moretrees:slab_spruce_planks"           )
cvt ("moretrees:slab_spruce_planks_2"         ,
     "moretrees:slab_spruce_planks"           )

cvt ("moretrees:stair_oak_planks_alt_4"       ,
     "moretrees:stair_oak_planks"             )

-- ===================================================================

cvt ("stairs:slab_moretrees_sequoia_planks"   ,
     "stairs:slab_sequoia_wood"               )
cvt ("stairs:stair_moretrees_sequoia_planks"  ,
     "stairs:stair_sequoia_wood"              )

cvt ("stairs:slab_moretrees_poplar_planks"    ,
     "stairs:slab_poplar_wood"                )
cvt ("stairs:stair_moretrees_poplar_planks"   ,
     "stairs:stair_poplar_wood"               )

-- ===================================================================
-- End of file.
