-- File:     codersea/codersea-turtle.lua
-- Purpose:  CoderSea turtle support module
-- Credits:  See "codersea.md"
-- Licenses: See "LICENSE"

local l_spawn_in   = {
    "codersea:water_source"       ,
    "codersea:water_flowing"      ,
    "codersea:water_gel"          ,
    "default:water_source"        ,
    "default:water_flowing"       ,
}

local l_spawn_near   = {
    "darkage:silt"           ,
    "default:sand"           ,
    "default:dirt"           ,
    "ethereal:dry_dirt"      ,
    "ethereal:green_dirt"    ,
    "ethereal:grove_dirt"    ,
    "ethereal:mushroom_dirt" ,
    "group:sand"             ,
    "group:soil"             ,
}

local spawnchance = codersea_chance_turtle
if    spawnchance < 300 then
      spawnchance = 300 end

local l_colors = {
    "#604000:175",  --brown
    "#604000:100",  --brown2
    "#ffffff:150",  --white
    "#404040:150",  --dark_grey
    "#a0a0a0:150",  --grey
    "#808000:150",  --olive
    "#ff0000:150"   --red
}

local l_skins = {
    { "codersea_turtle1.png^codersea_turtle2.png^codersea_turtle3.png^codersea_turtle4.png^codersea_turtle5.png^codersea_turtle6.png^codersea_turtle7.png" } ,
    { "codersea_turtle1.png^(codersea_turtle2.png^[colorize:"..l_colors[5]..")^(codersea_turtle3.png^[colorize:"..l_colors[4]..")^(codersea_turtle4.png^[colorize:"..l_colors[1]..")^(codersea_turtle5.png^[colorize:"..l_colors[2]..")^(codersea_turtle6.png^[colorize:"..l_colors[6]..")^codersea_turtle7.png" }
}

local l_anims = {
    speed_normal = 24, speed_run =  24,
    stand_start  =  1, stand_end =  50,
    walk_start   = 60, walk_end  =  90,
    run_start    = 60, run_end   =  90,
    hide_start   = 95, hide_end  = 100,
}

local l_model        = "codersea_turtle.x"
local spawnchance    = 30000

mobs:register_mob ("codersea:seaturtle", {
    do_custom = mob_custom,
    type = "animal",
    passive = true,
    hp_min = 20,
    hp_max = 30,
    armor = 250,
    collisionbox = {-0.8, 0.0, -0.8, 0.8, 0.7, 0.8},
    visual = "mesh",
    visual_size = {x=2,y=2},
    mesh = l_model,
    textures = l_skins,
    makes_footstep_sound = false,
    view_range = 10,
    rotate = 270,
    walk_velocity = 1,
    run_velocity = 1.5,
    stepheight = 1,
    jump = false,
    fly = true,
    fly_in = fly_water,
    fall_speed = 0,
    floats = 1,
    water_damage = 0,
    lava_damage = 5,
    light_damage = 0,
    fall_damage = 0,
    animation = l_anims,

    on_rightclick = function (self, clicker)
        mobs:capture_mob (self, clicker,
            0, 0, 80, true, nil)
    end
})

mobs:spawn_specific ("codersea:seaturtle",
    l_spawn_in, l_spawn_near,
    5, 20, 30, spawnchance, codersea_aoc_turtle, -31000, -1)

mobs:register_egg ("codersea:seaturtle",
    "Sea Turtle", "default_water.png", 1)
