-- ===================================================================

function default.node_sound_defaults (table)
    table = table or {}
    table.footstep = table.footstep or
            {name = "", gain = 1.0}
    table.dug = table.dug or
            {name = "default_dug_node", gain = 0.25}
    table.place = table.place or
            {name = "default_place_node_hard", gain = 1.0}
    return table
end

-- ===================================================================

function default.node_sound_dirt_defaults (table)
    table = table or {}
    table.footstep = table.footstep or
            {name = "default_dirt_footstep", gain = 1.0}
    table.dug = table.dug or
            {name = "default_dirt_footstep", gain = 1.5}
    table.place = table.place or
            {name = "default_place_node", gain = 1.0}
    default.node_sound_defaults (table)
    return table
end
default.sound_dirt = default.node_sound_dirt_defaults

-- ===================================================================

function default.node_sound_glass_defaults (table)
    table = table or {}
    table.footstep = table.footstep or
            {name = "default_glass_footstep", gain = 0.5}
    table.dug = table.dug or
            {name = "default_break_glass", gain = 1.0}
    default.node_sound_defaults (table)
    return table
end
default.sound_glass = default.node_sound_glass_defaults

-- ===================================================================

function default.node_sound_gravel_defaults (table)
    table = table or {}
    table.footstep = table.footstep or
            {name = "default_gravel_footstep", gain = 0.5}
    table.dug = table.dug or
            {name = "default_gravel_footstep", gain = 1.0}
    table.place = table.place or
            {name = "default_place_node", gain = 1.0}
    default.node_sound_defaults (table)
    return table
end
default.sound_gravel = default.node_sound_gravel_defaults

-- ===================================================================

function default.node_sound_leaves_defaults (table)
    table = table or {}
    table.footstep = table.footstep or
            {name = "default_grass_footstep", gain = 0.35}
    table.dug = table.dug or
            {name = "default_grass_footstep", gain = 0.7}
    table.dig = table.dig or
            {name = "default_dig_crumbly", gain = 0.4}
    table.place = table.place or
            {name = "default_place_node", gain = 1.0}
    default.node_sound_defaults (table)
    return table
end
default.sound_leaves = default.node_sound_leaves_defaults

-- ===================================================================

function default.node_sound_metal_defaults (table)
    table = table or {}
    table.footstep = table.footstep or
            {name = "default_metal_footstep", gain = 0.4}
    table.dig = table.dig or
            {name = "default_dig_metal", gain = 0.5}
    table.dug = table.dug or
            {name = "default_dug_metal", gain = 0.5}
    table.place = table.place or
            {name = "default_place_node_metal", gain = 0.5}
    default.node_sound_defaults (table)
    return table
end
default.sound_metal = default.node_sound_metal_defaults

-- ===================================================================

function default.node_sound_sand_defaults (table)
    table = table or {}
    table.footstep = table.footstep or
            {name = "default_sand_footstep", gain = 0.12}
    table.dug = table.dug or
            {name = "default_sand_footstep", gain = 0.24}
    table.place = table.place or
            {name = "default_place_node", gain = 1.0}
    default.node_sound_defaults (table)
    return table
end
default.sound_sand = default.node_sound_sand_defaults

-- ===================================================================

function default.node_sound_snow_defaults (table)
    table = table or {}
    table.footstep = table.footstep or
            {name = "default_snow_footstep", gain = 0.2}
    table.dig = table.dig or
            {name = "default_snow_footstep", gain = 0.3}
    table.dug = table.dug or
            {name = "default_snow_footstep", gain = 0.3}
    table.place = table.place or
            {name = "default_place_node", gain = 1.0}
    default.node_sound_defaults (table)
    return table
end
default.sound_snow = default.node_sound_snow_defaults

-- ===================================================================

function default.node_sound_stone_defaults (table)
    table = table or {}
    table.footstep = table.footstep or
            {name = "default_hard_footstep", gain = 0.5}
    table.dug = table.dug or
            {name = "default_hard_footstep", gain = 1.0}
    default.node_sound_defaults (table)
    return table
end
default.sound_stone = default.node_sound_stone_defaults

-- ===================================================================

function default.node_sound_water_defaults (table)
    table = table or {}
    table.footstep = table.footstep or
            {name = "default_water_footstep", gain = 0.2}
    default.node_sound_defaults (table)
    return table
end
default.sound_water = default.node_sound_water_defaults

-- ===================================================================

function default.node_sound_wood_defaults (table)
    table = table or {}
    table.footstep = table.footstep or
            {name = "default_wood_footstep", gain = 0.5}
    table.dug = table.dug or
            {name = "default_wood_footstep", gain = 1.0}
    default.node_sound_defaults (table)
    return table
end
default.sound_wood = default.node_sound_wood_defaults

-- ===================================================================
-- End of file.
