-- ===================================================================
-- "ufoods" common header.

local S
if minetest.get_modpath ("intllib") then
    S = intllib.Getter()
else
    S = function (s) return s end
end

local item_eat     = unified_foods.item_eat
local keep_vessels = unified_foods.keep_vessels
local mra          = minetest.registered_aliases
local mri          = minetest.registered_items

local reg_alias    = ocutil.safe_register_alias
local reg_craft    = minetest.register_craft
local reg_food     = unified_foods.register_food
local reg_item     = ocutil.safe_register_item
local reg_juice    = unified_foods.register_juice

local needitem

-- ===================================================================
-- Apple.

needitem = reg_food ("apple",
    {
        description    = "Apple" ,
        satiate        = 2       ,
        heal           = 1       ,

        external_items = {
            "coderfruit:apple" , "default:apple" , "fruit:apple" ,
            "treefruit:apple"  ,
        } ,
    })

-- ===================================================================
-- Apple Juice.

needitem = reg_juice ("apple",
    {
        satiate = 2         ,
        color   = "#FFC929" ,
    } ,
    { "mtfoods:apple_juice" })

reg_alias ("mtfoods:apple_juice" , needitem)

-- ===================================================================
-- Banana.

needitem = reg_food ("banana",
    {
        description    = "Banana"     ,
        satiate        = 3            ,
        heal           = 2            ,

        external_items = {
            "coderfruit:banana"   , "farming:banana"  ,
            "farming_plus:banana" , "ethereal:banana" ,
        } ,
    })

reg_craft ({
    output = needitem ,
    recipe = {
        { "default:apple" }, { "default:apple" }
    }
})

reg_alias ("banna", needitem)

-- ===================================================================
-- Banana Juice.

needitem = reg_juice ("banana",
    {
        satiate = 2         ,
        color   = "#E3CCAB" ,
    })

-- ===================================================================
-- Cherry (or Cherries).

needitem = reg_food ("cherry",
    {
        description    = "Cherries"          ,
        img_prefix     = "coderfruit"        ,
        satiate        = 2                   ,
        extra_groups   = { food_cherries=1 } ,
        external_items = "coderfruit:cherry" ,
    })

reg_alias ("cherries"      , needitem)
reg_alias ("food:cherries" , needitem)

-- ===================================================================
-- Cherry Juice.

needitem = reg_juice ("cherry",
    {
        satiate = 2         ,
        color   = "#CD2B2D" ,
    })

-- ===================================================================
-- Melon.

-- Unified Foods doesn't  presently provide a melon.  Melons come from
-- "farming", if present, and  are nodes  as  opposed to  craft-items.
-- "crops:melon"  is implemented simply as an alias to  the melon node
-- in "farming".

reg_alias ("farming:melon" , "farming:melon_8")
reg_alias ("crops:melon"   , "farming:melon_8")

-- ===================================================================
-- Orange.

needitem = reg_food ("orange",
    {
        description    = "Orange" ,
        satiate        = 2        ,

        external_items = {
            "coderfruit:orange"   , "ethereal:orange"          ,
            "farming:orange_item" , "farming_plus:orange_item" ,
            "fruit:orange"        , "treefruit:orange"         ,
        } ,
    })

-- ===================================================================
-- Orange Juice.

needitem = reg_juice ("orange",
    {
        satiate = 2         ,
        color   = "#fcc510" ,
    } ,
    { "mtfoods:orange_juice" })

reg_alias ("oj"                   , needitem)
reg_alias ("mtfoods:orange_juice" , needitem)

-- ===================================================================
-- Strawberry.

needitem = reg_food ("strawberry",
    {
        description    = "Strawberry" ,
        satiate        = 1            ,

        external_items = {
            "ethereal:strawberry" , "farming_plus:strawberry_item" ,
            "plantlib:strawberry" ,
        } ,
    })

reg_alias ("ethereal:strawberry", needitem)

-- ===================================================================
-- Strawberry Juice.

needitem = reg_juice ("strawberry",
    {
        satiate = 2         ,
        color   = "#F63535" ,
    })

-- ===================================================================
-- End of file.
