-- Bear. Descended from Farlands version.

-- ===================================================================

local lcname     = "bear"
local ucname     = "Bear"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance =  50000       ,

    day_mode     = true         ,
    min_light    =      0       ,
    max_light    =     10       ,
    min_height   = -31000       ,
    max_height   =  11000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_with_dry_grass"       ,
        "fargen:dirt_with_leafy_grass"      ,
    } ,

    add_egg   = true                        ,
    egg_image = "codermobs_bear_fur.png"    ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    passive = false,
    reach = 2.2,
    damage = 3,
    attack_type = "dogfight",
    hp_min = 30,
    hp_max = 40,
    armor = 100,
    visual_size = {x=1, y=1},
    collisionbox = {-0.7, 0,-0.7, 0.7,1.8,0.7},
    visual = "mesh",
    mesh = msname .. ".b3d",

    textures = {
        { msname .. ".png"},
    },

    blood_texture = "default_dirt.png",
    makes_footstep_sound = true,
    walk_velocity = 1,
    run_velocity = 2,
    stepheight    = 1.2         ,
    jump_height   =   0         ,
    jump          = false       ,
    water_damage = 1,
    floats = 0,
    runaway = true,
    lava_damage = 2,
    light_damage = 0,
    fall_damage = 1,
    view_range = 10,

    drops = {
        { name="mobs:meat_raw", chance=2, min=1, max=2 } ,
    } ,

    on_rightclick = function(self, clicker)
        local item = clicker:get_wielded_item()
        if item:get_name() == "mobs_m:smallfish_raw" then
            item:take_item()
            self.state = "stand"
            self.object:set_animation({x=55, y=75}, 18, 0)
        end
    end,

    animation = {
        speed_normal = 14,
        speed_run = 18,
        stand_start = 1,
        stand_end = 11,
        walk_start = 15,
        walk_end = 30,
        run_start = 15,
        run_end = 30,
        punch_start = 35,
        punch_end = 50,
    } ,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
