-- Beetle. Descended from Farlands version.

-- ===================================================================

local lcname     = "beetle"
local ucname     = "Beetle"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance =  70000       ,

    day_mode     = true         ,
    min_light    =      0       ,
    max_light    =     10       ,
    min_height   = -31000       ,
    max_height   =  11000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:desert_sand"               ,
        "default:dirt_with_dry_grass"       ,
        "fargen:dirt_with_leafy_grass"      ,
        "noisegrid:grass"                   ,
    } ,

    add_egg   = true                        ,
    egg_image = "default_desert_sand.png"   ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    passive = false,
    reach = 1,
    damage = 1,
    attack_type = "dogfight",
    hp_min = 10,
    hp_max = 20,
    armor = 110,
    collisionbox = {-0.35,0,-0.35, 0.35,0.8,0.35},
    visual = "mesh",
    mesh = msname .. ".b3d",
    textures = {
        { msname .. ".png"},
    },
    blood_texture = "mobs_blood.png",
    makes_footstep_sound = true,
    walk_velocity = 1,
    run_velocity = 1.5,
    stepheight    = 1.2         ,
    jump_height   =   0         ,
    jump          = false       ,
    water_damage = 2,
    floats = 0,
    runaway = true,
    lava_damage = 2,
    light_damage = 0,
    fall_damage = 1,
    view_range = 15,

    drops = {
        { name="default:dirt",
          chance=2, min=1, max=1 } ,
    } ,

    animation = {
        speed_normal = 27,
        speed_run = 27,
        stand_start = 1,
        stand_end = 20,
        walk_start = 25,
        walk_end = 45,
        run_start = 25,
        run_end = 45,
        punch_start = 1,
        punch_end = 20,
    } ,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
