-- Cacodemon. From "D00Med" mobs. Add more credits here.

-- ===================================================================

local lcname     = "cacodemon"
local ucname     = "Cacodemon"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs:register_arrow ("codermobs:fireball_4", {
    visual = "sprite",
    visual_size = {x = 1, y = 1},
    textures = { "doom_plasma.png" } ,
    velocity = 6,
    tail = 0, -- enable tail

   hit_player = function(self, player)
      player:punch(self.object, 1.0, {
         full_punch_interval = 1.0,
         damage_groups = {fleshy = 3},
      }, nil)
   end,

   hit_mob = function(self, player)
      player:punch(self.object, 1.0, {
         full_punch_interval = 1.0,
         damage_groups = {fleshy = 3},
      }, nil)
   end,

   hit_node = function(self, pos, node)
      self.object:remove()
   end,
})

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance = 120000       ,

    day_mode     = false        ,
    min_light    =      0       ,
    max_light    =     20       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    spawn_type   = "monster"    ,

    spawn_nodes  = {
        "default:lava_flowing"          ,
        "default:lava_crust_flowing"    ,
        "fire:basic_flame"              ,
        "hell:soul_stone"               ,
    } ,

    add_egg   = true                    ,
    egg_image = "wool_red.png"          ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type             = mobs_param.spawn_type    ,
    passive          = false                    ,
    pathfinding      = true                     ,
    attacks_monsters = true                     ,
    damage           =  8                       ,
    reach            =  3                       ,
    attack_type      = "shoot"                  ,
    shoot_interval   = 2.5                      ,
    arrow            = "codermobs:fireball_4"   ,
    shoot_offset     =  1                       ,
    hp_min           = 40                       ,
    hp_max           = 55                       ,
    armor            = 80                       ,

    blood_amount     = 80                       ,
    walk_velocity    =  3                       ,
    run_velocity     =  5                       ,
    jump             = true                     ,
    fly              = true                     ,
    fall_speed       =  0                       ,
    stepheight       = 10                       ,
    water_damage     =  3                       ,
    lava_damage      =  -1                       ,
    light_damage     =  0                       ,
    view_range       = 20                       ,

    blood_texture    = "doom_plasma.png"                    ,
    collisionbox     = { -0.9, -0.2, -0.9, 0.9, 1.5, 0.9 }  ,
    mesh             = msname .. ".b3d"                     ,
    textures         = {{ msname .. ".jpg" }}               ,
    visual           = "mesh"                               ,
    visual_size      = { x=2, y=2 }                         ,

    makes_footstep_sound = true ,

    sounds = {
        attack  = "dsfirsht" ,
        death   = "dscacdth" ,
        war_cry = "dsfirsht" ,
    } ,

    animation = {
        speed_normal = 10 ,
        speed_run    = 20 ,
        stand_start  =  1 ,
        stand_end    = 20 ,
        walk_start   =  1 ,
        walk_end     = 20 ,
        run_start    =  1 ,
        run_end      = 20 ,
        shoot_start  = 20 ,
        shoot_end    = 40 ,
    } ,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
