-- Cyberdemon. From "D00Med" mobs. Add more credits here.

-- ===================================================================

local lcname   = "cyberdemon"
local ucname   = "Cyberdemon"
local msname   = "codermobs_" .. lcname
local obj_name = "codermobs:" .. lcname

-- ===================================================================

mobs:register_arrow ("codermobs:rocket", {
   visual = "sprite",
   visual_size = {x = 0.5, y = 0.5},
   textures = {"doom_rocket.png"},
   velocity = 8,
   tail = 1, -- enable tail
   tail_texture = "doom_rocket_smoke.png",

   hit_player = function(self, player)
      player:punch(self.object, 1.0, {
         full_punch_interval = 1.0,
         damage_groups = {fleshy = 3},
      }, nil)
   end,

   hit_mob = function(self, player)
      player:punch(self.object, 1.0, {
         full_punch_interval = 1.0,
         damage_groups = {fleshy = 3},
      }, nil)
   end,

   hit_node = function(self, pos, node)
      self.object:remove()
   end,
})

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance = 120000       ,

    day_mode     = false        ,
    min_light    =      0       ,
    max_light    =     20       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    spawn_type   = "monster"    ,

    spawn_nodes  = {
        "default:dirt_with_grass"       ,
        "hell:soul_stone"               ,
        "nether:stone"                  ,
        "noisegrid:grass"               ,
    } ,

    add_egg   = true                    ,
    egg_image = "wool_red.png"          ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type             = mobs_param.spawn_type    ,
    passive          = false                    ,
    reach            =   6                      ,
    damage           =   2                      ,
    attack_type      = "shoot"                  ,
    shoot_interval   =   1.5                    ,
    arrow            = "codermobs:rocket"       ,
    shoot_offset     =  -1                      ,
    hp_min           = 132                      ,
    hp_max           = 172                      ,
    armor            = 100                      ,
    walk_velocity    =   1                      ,
    run_velocity     =   2.1                    ,
    jump             = true                     ,

    collisionbox     = { -0.9, 0, -0.9, 0.9, 6.5, 0.9 } ,
    visual           = "mesh"                           ,
    mesh             = "codermobs_cyberdemon.b3d"       ,
    textures         = {{ "mobs_cyberdemon2.jpg" }}     ,
    blood_amount     = 90                               ,
    blood_texture    = "doom_blood_effect.png"          ,
    visual_size      = { x=2, y=2 }                     ,

    makes_footstep_sound = true,

    drops = {
        { name="default:mese"  , chance=2, min=1, max=1 } ,
        { name="mobs:meat_raw" , chance=1, min=3, max=5 } ,
    } ,

    on_activate = function (self)
        self.texchanged = false
    end,

    do_custom = function (self)
        local pos = self.object:getpos()
        if pos == nil then
            self.object:remove()
            return
        end
        local node = minetest.get_node({x=pos.x, y=pos.y-1, z=pos.z}).name
        if node == "hell:soul_stone" and self.texchanged == false then
        self.object:set_properties({textures = {"mobs_cyberdemon.jpg"}})
        self.textchanged = true
        end
    end,

    water_damage =  0 ,
    lava_damage  =  0 ,
    light_damage =  0 ,
    view_range   = 15 ,

    sounds = {
        attack  = "dsrlaunc" ,
        death   = "dscybdth" ,
        random  = "dsdmact"  ,
        war_cry = "dsrlaunc" ,
    } ,

    animation = {
        speed_normal = 10 ,
        speed_run    = 15 ,
        walk_start   = 20 ,
        walk_end     = 40 ,
        run_start    = 20 ,
        run_end      = 40 ,
        stand_start  = 64 ,
        stand_end    = 80 ,
        shoot_start  =  1 ,
        shoot_end    = 15 ,
    } ,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
