-- Dirt Monster.

-- ===================================================================

local lcname     = "dirt_monster"
local ucname     = "Dirt Monster"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance =  20000       ,

    day_mode     = false        ,
    min_light    =      0       ,
    max_light    =      7       ,
    min_height   =      0       ,
    max_height   =     20       ,

    spawn_type   = "monster"    ,

    spawn_nodes  = {
        "default:dirt"             ,
        "default:dirt_with_grass"  ,
        "ethereal:gray_dirt"       ,
        "noisegrid:grass"          ,
    } ,

    add_egg   = true               ,
    egg_image = "default_dirt.png" ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,

    armor         = 100          ,
    attack_type   = "dogfight"   ,
    damage        =   2          ,
    attack_animals = true           ,
    fear_height   =   4          ,
    hp_min        =   3          ,
    hp_max        =  27          ,
    stepheight    = 1.2          ,
    jump_height   =   0          ,
    jump          = false        ,
    lava_damage   =   5          ,
    light_damage  =   3          ,
    passive       = false        ,
    pathfinding   = true         ,
    reach         =   2          ,
    run_velocity  =   3          ,
    view_range    =  15          ,
    walk_velocity =   1          ,
    water_damage  =   1          ,
    floats = 0,
    runaway = true,

    makes_footstep_sound = true  ,

    drops = {
        { name = "default:dirt", chance=1, min=3, max=5 } ,
    } ,

    sounds = {
        random = "codermobs_dirt_monster" ,
    },

    animation = {
        speed_normal = 15 ,
        speed_run    = 15 ,
        stand_start  =  0 ,
        stand_end    = 14 ,
        walk_start   = 15 ,
        walk_end     = 38 ,
        run_start    = 40 ,
        run_end      = 63 ,
        punch_start  = 40 ,
        punch_end    = 63 ,
    },

    textures = {
        { "codermobs_dirt_monster.png" } ,
    },

    blood_texture = "default_dirt.png"                ,
    collisionbox  = { -0.4, -1, -0.4, 0.4, 0.8, 0.4 } ,
    mesh          = "codermobs_stone_monster.b3d"     ,
    visual        = "mesh"                            ,
}

-- ===================================================================

codermobs.setup_mob()
mobs:alias_mob ("mobs_monster:dirt_monster" , obj_name)
codermobs.log_done()

-- ===================================================================
-- End of file.
