-- Jeraf. Descended from kpgmobs version.

-- ===================================================================

local lcname     = "jeraf"
local ucname     = "Jeraf"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance = 120000       ,

    day_mode     = true         ,
    min_light    =     10       ,
    max_light    =     20       ,
    min_height   = -31000       ,
    max_height   =  31000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "darkage:silt"                  ,
        "default:desert_sand"           ,
        "default:dry_dirt"              ,
        "default:dirt_with_dry_grass"   ,
        "default:dirt_with_grass"       ,
        "default:silver_sand"           ,
        "earthgen:dirt_with_dry_grass"  ,
        "ethereal:green_dirt"           ,
        "ethereal:green_dirt_top"       ,
        "ethereal:grove_dirt"           ,
        "mg:dirt_with_dry_grass"        ,
        "noisegrid:grass"               ,
    } ,

    add_egg   = true                    ,
    egg_image = "wool_yellow.png"       ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    makes_footstep_sound = true  ,

    armor         = 200          ,
    hp_min        =   5          ,
    hp_max        =  10          ,
    floats        =   0          ,
    runaway       = true         ,
    view_range    =   5          ,
    walk_velocity =   2          ,
    stepheight    = 1.2          ,
    jump_height   =   0          ,
    jump          = false        ,

    lava_damage   =   5          ,
    light_damage  =   0          ,
    water_damage  =   1          ,
    floats = 0,
    runaway = true,

    collisionbox  = { -0.40, -0.01, -0.40, 0.40, 1.00, 0.40 } ,
    drawtype      = "front"                                   ,
    mesh          = msname .. ".x"                            ,
    textures      = {{ msname .. ".png" }}                    ,
    visual        = "mesh"                                    ,

    animation = {
        stand_start  =   0 ,
        stand_end    =  30 ,
        walk_start   =  70 ,
        walk_end     = 100 ,
        speed_normal =  15 ,
    } ,

    drops = {
        { name="mobs:meat_raw", chance=1, min=2, max=3 } ,
    } ,

    follow = "farming:wheat" ,
}

-- ===================================================================

codermobs.setup_mob()
mobs:alias_mob ("codermobs:giraffe" , obj_name)
mobs:alias_mob ("mobs:jeraf"        , obj_name)
codermobs.log_done()

-- ===================================================================
-- End of file.
