-- Koala. From Animal-World.

-- ===================================================================

local lcname     = "koala"
local ucname     = "Koala"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =   -1         ,
    spawn_chance = 3000         ,

    day_mode     = true         ,
    min_light    =    0         ,
    max_light    =   30         ,
    min_height   =    1         ,
    max_height   =  150         ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_gray"                   ,
        "default:dirt_with_coniferous_litter" ,
        "default:dry_dirt_with_dry_grass"     ,
        "ethereal:bamboo_dirt"                ,
        "ethereal:dry_dirt"                   ,
        "ethereal:grass_grove"                ,
        "ethereal:green_dirt"                 ,
        "ethereal:mushroom_dirt"              ,
        "naturalbiomes:outback_litter"        ,
    } ,

    add_egg   = true            ,
    egg_image = "egg_koala.png" ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    makes_footstep_sound = true  ,

    armor         =  100         ,
    attack_npcs   = true         ,
    attack_type   = "dogfight"   ,
    damage        =    1         ,
    fear_height   =    9         ,
    floats        =    0         ,
    group_attack  = true         ,
    hp_max        =   30         ,
    hp_min        =    5         ,
    jump          = false        ,
    jump_height   =    8         ,
    owner_loyal   = true         ,
    passive       = false        ,
    pushable      = true         ,
    reach         =    2         ,
    run_velocity  =    1         ,
    runaway       = true         ,
    stepheight    =    2         ,
    view_range    =    6         ,
    walk_chance   =   25         ,
    walk_velocity =    0.5       ,

    air_damage    =    0         ,
    lava_damage   =    5         ,
    light_damage  =    0         ,
    water_damage  =    1         ,

    collisionbox  = { -0.30, -0.01, -0.30, 0.30, 0.20, 0.30 } ,
    mesh          =    msname .. ".b3d"    ,
    textures      = ocutil.multtext ({{ msname .. ".png" }} , 18) ,
    visual        = "mesh"                 ,

    animation = {
        speed_normal =  50   ,
        stand_speed  =  25   ,
        stand_start  = 100   ,
        stand_end    = 200   ,
        stand1_start = 200   ,
        stand1_end   = 300   ,

        walk_start   =   0   ,
        walk_end     = 100   ,

        punch_speed  = 100   ,
        punch_start  = 300   ,
        punch_end    = 400   ,

        die_start    = 300   ,
        die_end      = 400   ,
        die_speed    =  50   ,
        die_loop     = false ,
        die_rotate   = true  ,
    },

    drops = {
        { name="mobs:meat_raw", chance=1, min=1, max=1 } ,
    } ,

    follow        = {
        "default:grass_3"         ,
        "default:dry_grass_3"     ,
        "ethereal:dry_shrub"      ,
        "farming:lettuce"         ,
        "farming:seed_wheat"      ,
        "default:junglegrass"     ,
    } ,

    runaway_from  = {
        "animalworld:bear"        ,
        "animalworld:crocodile"   ,
        "animalworld:tiger"       ,
        "animalworld:spider"      ,
        "animalworld:spidermale"  ,
        "animalworld:shark"       ,
        "animalworld:hyena"       ,
        "animalworld:kobra"       ,
        "animalworld:monitor"     ,
        "animalworld:snowleopard" ,
        "animalworld:volverine"   ,
        "player"
    } ,

    sounds = {
    } ,

    on_rightclick = function (self, clicker)
        if mobs:feed_tame    (self, clicker, 8, true, true) then
            return
        end
        if mobs:protect      (self, clicker) then return end
        if mobs:capture_mob  (self, clicker,
0, 5, 50, false, nil) then
            return
        end
    end ,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
