-- Mammoth. Descended from Farlands version.

-- ===================================================================

local lcname     = "mammoth"
local ucname     = "Mammoth"
local msname     = "codermobs_" .. lcname
local obj_name   = "codermobs:" .. lcname

-- ===================================================================

mobs_param = {
    lcname       = lcname       ,
    ucname       = ucname       ,
    obj_name     = obj_name     ,

    aoc          =     -1       ,
    spawn_chance = 100000       ,

    day_mode     = true         ,
    min_light    =     10       ,
    max_light    =     20       ,
    min_height   = -31000       ,
    max_height   =  11000       ,

    spawn_type   = "animal"     ,

    spawn_nodes  = {
        "default:dirt_with_dry_grass"           ,
    } ,

    add_egg   = true                            ,
    egg_image = "codermobs_mammoth_wool.png"    ,
}

-- ===================================================================

codermobs.adjust_param()

-- ===================================================================

mobs_param.core_param = {
    type = mobs_param.spawn_type ,
    passive = false,
    reach = 3,
    damage = 5,
    attack_type = "dogfight",
    hp_min = 50,
    hp_max = 60,
    armor = 100,
    collisionbox = {-1.6, 0, -1.6, 1.6, 3.3, 1.6},
    visual = "mesh",
    mesh = msname .. ".b3d",
    textures = {
        { msname .. ".png"},
    },
    blood_texture = "mobs_blood.png",
    makes_footstep_sound = true,
    walk_velocity = 0.5,
    run_velocity = 1,
    stepheight    = 1.2         ,
    jump_height   =   0         ,
    jump          = false       ,
    water_damage = 2,
    floats = 0,
    runaway = true,
    lava_damage = 2,
    light_damage = 0,
    fall_damage = 1,
    fall_speed = -20, -- extra heavy!
    fear_height = 2,
    replace_rate = 10,
    replace_what = {"default:grass_3", "default:grass_4", "default:grass_5", "ethereal:bamboo"},
    replace_with = "air",

    follow = {
        "compactblocks:default_leaves" ,
    } ,

    view_range = 14,

    drops = {
        { name="mobs:meat_raw", chance=2, min=5, max=6 } ,
    } ,

    specific_attack = codermobs.make_mob_list ({
        "farhorse", "zebra",
    }) ,

    animation = {
        speed_normal = 15,
        speed_run = 17,
        walk_start = 45,
        walk_end = 65,
        stand_start = 20,
        stand_end = 40,
        run_start = 45,
        run_end = 65,
        punch_start = 1,
        punch_end = 20,

    },
    on_rightclick = function(self, clicker)

        if mobs:feed_tame(self, clicker, 8, true, true) then
            return
        end

        mobs:capture_mob(self, clicker, 0, 5, 50, false, nil)
    end,
}

-- ===================================================================

codermobs.setup_mob()
codermobs.log_done()

-- ===================================================================
-- End of file.
